package DataChangePackage;
use Exporter;
require Exporter;
@ISA = ('Exporter');
@EXPORT = ('TableMigration', 'DhcpRelayTable','Qosupdates', 'Interface_Index_Change', 'Interface_Index_Change','Default_Vrf_ID_Change','FPVRF_Index_search','FPVRF_Index_insert');

use IO::File;
use POSIX;
use strict;
sub TableMigration
{
    my($refConfigArray,$pathref)=@_;
    my @ConfigArray=@{$refConfigArray};
    my @TempConfigArray=@ConfigArray;
    my $count=0;
    my $ConfigCount=0;
    my $ConfigCopy=0;
    my $TempCount=0;
    my $IndexValue=0;
    my $NewConfigCount=0;
    my @NewConfigArray ;
    my $TempIndexCount;
    my $Flag=0;
    my $IndexCount = 0;
    my @OldTableIndex ; #Jayalk 
    my $filepath = $$pathref . "/TableMigration"; 
    my $FileHandle = IO::File->new($filepath, "r") || 
       die "Could not open File For TableMigration \n";  
    my @TableMigraArray = <$FileHandle>;
    $FileHandle->close();     
    
     my @IndexArray = 0;
     my @IfMainIndexArray = 0; #Jayalk[15/3/2006]
                   
     for(@TableMigraArray)
     {   
                     
         my @ObjectName=split(/\s+/, $TableMigraArray[$count++]);

         for(@TempConfigArray)
         {
                my  @TempArray=split(/\s+/, $TempConfigArray[$TempCount++]);

		if ($TempArray[0] =~ m/^$ObjectName[2]\b/)
		{
		     my @TempOldTableIndex =
                               split(/$ObjectName[2]/,$TempArray[0]);
	      	     @OldTableIndex = split(/\./, $TempOldTableIndex[1]);

                     #Jayalk [15/3/2006]			
		     $IndexArray[$IndexCount] = $TempArray[2];
		     $IfMainIndexArray[$IndexCount++] = $OldTableIndex[1];
                     my $RowStatus = 
                      $ObjectName[4].".".$OldTableIndex[1].".".$TempArray[2];
                      $_ = $RowStatus."\t"."2"."\t"." 5"."\n";
                 }
          }  

     }

    $count = 0;
    @ConfigArray = @TempConfigArray;
    for(@TableMigraArray)
    {
        my @ObjectName=split(/\s+/, $TableMigraArray[$count++]);
        if($ObjectName[0] =~ /\w+/)
        {
            $ConfigCopy=0;
            $ConfigCount=0;
            $NewConfigCount=0;

            $TempCount=0; 
                    
            my $TempIndexCount = 0;
            for(@ConfigArray)
            {
                my @FieldArray=split(/\s+/, $ConfigArray[$ConfigCount++]);
                my $SkipCopyFlag = 0; 
            
                if($FieldArray[0] =~ /\w+/)
                {
                 
                if($FieldArray[0] =~ m/^$ObjectName[0]\b/)
                {
		my @TempTokenName = split(/$ObjectName[0]/,$FieldArray[0]);
		my @TokenName = split(/\./,$TempTokenName[1]);

                if($IndexCount != 0)
                {
		   #Jayalk[15/3/2006]
	           if( $TokenName[1] =~ 
                         m/^$IfMainIndexArray[$TempIndexCount]$/ )
                   {
                    
                    $_=$ObjectName[1].".".$TokenName[1].".".
                         $IndexArray[$TempIndexCount++]."\t".
                          $FieldArray[1]."\t".$FieldArray[2]."\n";
	           }
		   else  
		   {
                      # Jayalk : Do not copy the Oid ,if IP was not
                      #          configured
                     $SkipCopyFlag = 1;
                   
	           }

	         }
                }
                 if( $SkipCopyFlag == 0 )
                 {
                      $NewConfigArray[$NewConfigCount++]=
                         $ConfigArray[$ConfigCopy++];
                 }
                 else
                 {
                  $SkipCopyFlag = 0; #reset to default val .
                  $ConfigCopy++;   # Do not copy the OID .

                 }
               }
            }
            @ConfigArray = @NewConfigArray;
        }    
    }
    
    $count = 0;
    $TempIndexCount = $IndexCount;
    $ConfigCopy = 0;
    $ConfigCount = 0;
    @TempConfigArray = @ConfigArray;

    for(@TableMigraArray)
    {
       my @ObjectName=split(/\s+/, $TableMigraArray[$count++]);
       for(@TempConfigArray)
       {
         my @FieldArray=split(/\s+/, $TempConfigArray[$ConfigCount]);
         
         $NewConfigArray[$ConfigCopy++] = $TempConfigArray[$ConfigCount++];
         if ($FieldArray[0] =~ /\w/)
         { 
            if($FieldArray[0] =~ m/^$ObjectName[3]\b/)
            {
               my @ArrayIndex = split(/$ObjectName[3]/, $FieldArray[0]);
               my $Index = join("", @ArrayIndex);
               $NewConfigArray[$ConfigCopy++] = 
                   $ObjectName[4].$Index."\t"."2"."\t"."1"."\n";

            }
         }  
       }
    }

my $retref= \@NewConfigArray;
    return $retref;
}

sub DhcpRelayTable
{
    my ($refConfigArray,$pathref)=@_;
    my @ConfigArray=@{$refConfigArray};
    my @TempConfigArray=@ConfigArray;
#Jayalk :
    my $filepath = $$pathref . "/DhcpRelayVrfTable" ;
    my $FileHandle = IO::File->new($filepath, "r") || 
                     die " Could not open file DhcpRelayVrfTable \n";
    my @TableArray = <$FileHandle>;
    $FileHandle->close();
    my $TableCount = 0;
    my $ConfigCount = 0;
    my $TempCount=0; 
    my @NewConfigArry = 0;
    my $NewConfigCount = 0;
    my $VrfIdValue = 0;
    my @ObjectList ;
    my $TempConfigCount ;
    for(@TableArray)
    {
        @ObjectList = split(/\s+/, $TableArray[$TableCount++]);
        if($ObjectList[0] =~ /\w+/)
        {
           $ConfigCount=0; 
           for(@ConfigArray)
           {
               my @FieldArray = split(/\s+/, $ConfigArray[$ConfigCount++]);
               if($FieldArray[0] =~ m/^$ObjectList[0]\b/)
               {
	          my @TempifMainIndex =
                      split(/$ObjectList[0]/,$FieldArray[0]); 
                  my @ifMainIndex = split(/\./, $TempifMainIndex[1]);
                  $TempConfigCount = 0; 
                  $NewConfigCount = 0;
                  $VrfIdValue = 0;
                  for(@TempConfigArray)
                  {
                      my @TempField =
                       split(/\s+/, $TempConfigArray[$TempConfigCount++]);

                      if($TempField[0] =~ m/^$ObjectList[2]\b/)
                      {
		          my @TempCheckIndex =
                            split(/$ObjectList[2]/,$TempField[0]);
                          my @CheckIndex = split(/\./, $TempCheckIndex[1]);
                          if($ifMainIndex[1] eq $CheckIndex[1])
                          {
                              $VrfIdValue = $TempField[2];
                              last;
                          }

                      }
                  }
                             my $DhcpStatus = $ObjectList[1].".".$VrfIdValue;
                              s/$FieldArray[0]/$DhcpStatus/;
               }
           }
        }
    }      
    my $RetRef = \@ConfigArray;
    return $RetRef; 
}


#Qos Changes
sub Qosupdates
{
my ($configref)=@_;
my @configuration =@$configref;
my $searchstring = "1.3.6.1.4.1.2076.90.5.1.2";
my @oldindex;
my @newindex;
my $i=0;
  for my $line (@configuration)
  {
	if($line =~ m/^$searchstring\b/)
	{
	#my @splitline = split (/\s+|\./,$line);
	my @word = split (/\s+/,$line);
	my @Tempsplitline = split(/$searchstring/,$word[0]);
	my @splitline = split(/\./,$Tempsplitline[1]);	

	$oldindex[$i]= $splitline[1];
#new ingressrate index starts from 3 and to 26 so add2 for the oldindex
	$newindex[$i]= $oldindex[$i]+2;
	$i++;
	}
  }
my $count = $i;
	  for($i=$count-1;$i>=0;$i--)
	  { 
          my @splitline ;
	  my $old=$oldindex[$i];
	  my $new=$newindex[$i];
	  my $src = $searchstring.".".$old;
          my $dest = $searchstring.".".$new;
  		for (@configuration)
		{
		my $line = $_;
		@splitline = split(/\s+/,$line);
	 	if($splitline[0] eq $src)
	 	{
         	 s/$src/$dest/;
		}
		}
	  }
return \@configuration;
}

sub Interface_Index_Change
{
    my ($indexValue)=@_;
  
    my $returnVal1 = "279";
    my $returnVal2 = "280";
    my $Index_change1 = "151";
    my $Index_change2 = "152";
    my $ToBeReturn = $indexValue;

       
       if($ToBeReturn =~ "151")
       {
          return $returnVal1;
       }
      
       if($ToBeReturn =~ "152")
       {
          return $returnVal2;
       }
 
          return $ToBeReturn;
}

sub Default_Vrf_ID_Change
{
	
        my ($Index_Value)=@_;
        my $returnIndex="0";
       
        
        if($Index_Value eq "1")
        {
           return $returnIndex;
        }
	
	return $Index_Value;
} 


sub ConvertMacToIP
{
 	my ($SentMacAdd, $SentVlanId, $IGMPFile) = @_;
	my  %ListMcIpAddress ;
	my  @HexMacAddress;
	my  @DecMacAddress;
	my  $HexIpAddress;
	my  @HexSpIpAddress;
	my  @DecSpIpAddress;
	my  $DottedDecIpAddress;
	my  @SpDecMacAddress; 
	my  $VlanId;
	my @DerivedDecMacAddress; 

	 my $tag = "";
	 my $i = 0;
	 my $flag = 0; 
         my $temp;
         my $retval;
	
	 my $refFileArray = parser ($IGMPFile);
	
	 my @FileArray = @{$refFileArray};

	 $i = 0;

	 for (@FileArray)
     {
		
			my %MacVlanArray;
			my @SplitFileArray = split(/\s+/, $_);
			if($SplitFileArray[0] eq "mcSrcAd")
			{
				$HexIpAddress = sprintf("%x", $SplitFileArray[1]);
				my $k = 0;
				for(my $j = 0; $j < 4 ; $j++)
				{
					
					$DecSpIpAddress[$j] = hex(substr($HexIpAddress, $k,2)); 	
					$k = int($k)+2;
				}
				$DottedDecIpAddress = join(".", @DecSpIpAddress);
				my $temp = $DecSpIpAddress[1];
				if ( int($temp) > 128 )
				{
					@SpDecMacAddress = ("1", "0", "94", $temp, $DecSpIpAddress[2], $DecSpIpAddress[3]);
					$DerivedDecMacAddress[0] = join(".", @SpDecMacAddress);		
	
					@SpDecMacAddress = ("1", "0", "94", int($temp)-128, $DecSpIpAddress[2], $DecSpIpAddress[3]);
					$DerivedDecMacAddress[1] = join(".", @SpDecMacAddress);	
			
				}
				if ( int($temp) < 128 )
				{
					@SpDecMacAddress = ("1", "0", "94", $temp, $DecSpIpAddress[2], $DecSpIpAddress[3]);
					$DerivedDecMacAddress[0] = join(".", @SpDecMacAddress);		

					@SpDecMacAddress = ("1", "0", "94", int($temp)+128, $DecSpIpAddress[2], $DecSpIpAddress[3]);
					$DerivedDecMacAddress[1] = join(".", @SpDecMacAddress);	
			
				}

			} 
			if($SplitFileArray[0] eq "vlanID")
			{
				$VlanId = $SplitFileArray[1];	
				my $temp = ($VlanId . "." . $DerivedDecMacAddress[0]);
				%ListMcIpAddress = (%ListMcIpAddress, $temp, $DottedDecIpAddress);
				$temp = ($VlanId . "." . $DerivedDecMacAddress[1]);
				%ListMcIpAddress = (%ListMcIpAddress, $temp, $DottedDecIpAddress);
				
			}
		}

	$temp = ($SentVlanId . "." . $SentMacAdd);
	$retval = $ListMcIpAddress{$temp};
	if (($retval eq "") || (length($retval) < 9))
	{
		$retval = "NULL";
	}
	return $retval; 
}


#  Mathewk [26/08/05] Starts
#
#  This subroutine extracts new Multicast address and
#  its VlanId from IGMPXmlfile.txt file
sub parser
{

    my ($IGMPXmlFile)  = @_;
    my $enddbName      = "</dbName>";
    my $endvalue       = "</value>";
    my $linecount      = 0;
    my $i              = 0;
    my @tempFileArray;
    my @data;
    my $flag;

    my $filehandle = IO::File->new($IGMPXmlFile,"r") or
        die "Error: Could not open $IGMPXmlFile \n";

    my @lines          = <$filehandle>;

    for (@lines)
    {

        if ($lines[$linecount++] =~ m/<dbName>/)
	{

             @data = split (/<dbName>|$enddbName/, $lines[$linecount-1]);
            if ($data[1] eq "mcSrcAd" || $data[1] eq "vlanID")
	    {

	        $tempFileArray[$i] = $data[1];
		$flag              = 1;
            }
	}

	if ($lines[$linecount] =~ m/<value>/)
	{

            @data = split (/<value>|$endvalue/, $lines[$linecount]);
	    if ($flag ==1)
	    {

                $tempFileArray[$i] = sprintf ("%s\t%s\n", $tempFileArray[$i], $data[1]);
		$flag              = 0;
		$i++;
	    }
	}
    }

    return \@tempFileArray;
}
#  Mathewk [26/08/05] Ends
#  (5889)
################################################################################
#Routine    : FPVRF_Index_search 
#Description: This sub routine will append .0 with the source OID and then
#             substitute the source OID with New OID taken from .DAT file 
#Input	    : oldobject,newobject,searchOID,the main configuration list reference 
#Output     : Mapped OID
################################################################################
#

sub FPVRF_Index_search
{
	my ($oldobject,$newobject,$searchOID,$configref)=@_;
	my $returnVal  = "0";
	my @lines      = @{$configref};
	my $tempobject = "";
	my $oldtemp = $oldobject.".0";
	my $Flag = "0";
	
	for(@lines)
	{
                if($Flag eq "1")
                {
                        s/$oldtemp\b/$tempobject/;
                        next;
                }
		my $templine=$_;
		my @words  = split (/\s+/, $templine);
                if($words[0] =~ m/^$searchOID\b/ and $words[2] eq "2" and $Flag eq "0")
                {
                        my @TempObjectIndex = split ($searchOID.".",$words[0]);
                        $tempobject = $newobject. "." .$TempObjectIndex[1];
                        $Flag = "1";
                }
	}
	if($Flag eq "0")
	{
		my @tempArray = " ";
		my $count       = 0;
		my $temp        = 0;

		print "\nWARNING !! Fast Path VRF is not present but RIP|OSPF configuration present !!\n";
		print "OID : ".$oldtemp;
		for (@lines) 
		{
			my @fields = split (/\s+/, $lines[$count]);
			if ($fields[0] !~ m/^$oldtemp\b/) 
			{
				$tempArray[$temp++] = $lines[$count];
			}
			$count++;
		}
		@lines = @tempArray; 
	}
	return (\@lines);
}
#  (5889)
################################################################################
#Routine    : FPVRF_Index_insert
#Description: This sub routine will just substitute the source OID with New OID taken from .DAT file
#	      Should be carefully used during scalar to tabular conversion
#Input	    : oldobject,newobject,searchOID,the main configuration list reference 
#Output     : Mapped OID
################################################################################
#
sub FPVRF_Index_insert
{
        my ($oldobject,$newobject,$searchOID,$configref)=@_;
        my $returnVal  = "0";
        my @lines      = @{$configref};
        my $tempobject = "";
        my $oldtemp = $oldobject;
        my $Flag = "0";

        for(@lines)
        {
                if($Flag eq "1")
                {
                        s/$oldtemp\b/$tempobject/;
                        next;
                }
                my $templine=$_;
                my @words  = split (/\s+/, $templine);
                if($words[0] =~ m/^$searchOID\b/ and $words[2] eq "2" and $Flag eq "0")
                {
                        my @TempObjectIndex = split ($searchOID.".",$words[0]);
                        $tempobject = $newobject. "." .$TempObjectIndex[1];
                        $Flag = "1";
                }

        }

	if($Flag eq "0")
	{
		my @tempArray = " ";
		my $count       = 0;
		my $temp        = 0;

		print "\nWARNING !! Fast Path VRF is not present but RIP|OSPF configuration present !!\n";
		print "OID : ".$oldtemp;
		for (@lines) 
		{
			my @fields = split (/\s+/, $lines[$count]);
			if ($fields[0] !~ m/^$oldtemp\b/) 
			{
				$tempArray[$temp++] = $lines[$count];
			}
			$count++;
		}
		@lines = @tempArray; 
	}
        return (\@lines);
}
